package com.tmax.openframe.variable;

import ch.obermuhlner.math.big.BigDecimalMath;
import com.tmax.openframe.variable.group.*;
import java.math.*;
import java.text.DecimalFormat;
import java.util.*;
import java.util.function.BiFunction;
import lombok.*;
import org.apache.commons.lang3.StringUtils;

/** 
 * <p>This source code was generated by COBOL to JAVA migrator</p>
 */
public class OIVPINSR_VariableContainer {
    public @Getter String WS_TRANS_ID = "OIIS";
    public @Getter String WS_MAPSET_NAME = "OIVPM04";
    public @Getter String WS_MAP_NAME = "OIVPM04";
    public @Getter @Setter int WS_RESPONSE_CODE;
    public @Getter @Setter int WS_RESPONSE_CODE2;
    public @Getter String WS_COMMUNICATION_AREA = StringUtils.repeat(' ', 1);
    public @Getter @Setter int WS_FIRST_TIME_FLAG;
    public @Getter @Setter OIVPINSR_WS_ERROR_MESSAGE WS_ERROR_MESSAGE = new OIVPINSR_WS_ERROR_MESSAGE();
    public @Getter @Setter OIVPINSR_OIVPM04I OIVPM04I = new OIVPINSR_OIVPM04I();

    public OIVPINSR_OIVPM04O getOIVPM04O() {
        return OIVPINSR_OIVPM04O.builder().FILLER12(getFILLER12())
                .FILLER13(getFILLER13()).DATEO(getDATEO())
                .FILLER14(getFILLER14()).TERMO(getTERMO())
                .FILLER15(getFILLER15()).TIMEO(getTIMEO())
                .FILLER16(getFILLER16()).IDENO(getIDENO())
                .FILLER17(getFILLER17()).NAMEO(getNAMEO())
                .FILLER18(getFILLER18()).DEPTO(getDEPTO())
                .FILLER19(getFILLER19()).PHONO(getPHONO())
                .FILLER20(getFILLER20()).EMALO(getEMALO())
                .FILLER21(getFILLER21()).ADDRO(getADDRO())
                .FILLER22(getFILLER22()).MSGO(getMSGO()).build();
    }

    public void setOIVPM04O(String source) {
        setFILLER12(source.substring(0, 12));
        setFILLER13(source.substring(12, 15));
        setDATEO(source.substring(15, 23));
        setFILLER14(source.substring(23, 26));
        setTERMO(source.substring(26, 30));
        setFILLER15(source.substring(30, 33));
        setTIMEO(source.substring(33, 41));
        setFILLER16(source.substring(41, 44));
        setIDENO(source.substring(44, 52));
        setFILLER17(source.substring(52, 55));
        setNAMEO(source.substring(55, 95));
        setFILLER18(source.substring(95, 98));
        setDEPTO(source.substring(98, 138));
        setFILLER19(source.substring(138, 141));
        setPHONO(source.substring(141, 181));
        setFILLER20(source.substring(181, 184));
        setEMALO(source.substring(184, 224));
        setFILLER21(source.substring(224, 227));
        setADDRO(source.substring(227, 267));
        setFILLER22(source.substring(267, 270));
        setMSGO(source.substring(270, 346));
    }

    public void setOIVPM04O(OIVPINSR_OIVPM04O source) {
        setOIVPM04O(source.toString());
    }

    public String getFILLER12() {
        return getOIVPM04I().getFILLER1();
    }

    public void setFILLER12(String source) {
        OIVPM04I.setFILLER1(source);
    }

    public String getFILLER13() {
        return String.valueOf(getOIVPM04I().getDATEL())
                + getOIVPM04I().getDATEF();
    }

    public void setFILLER13(String source) {
        OIVPM04I.setDATEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setDATEF(source.substring(2));
    }

    public String getDATEO() {
        return getOIVPM04I().getDATEI();
    }

    public void setDATEO(String source) {
        OIVPM04I.setDATEI(source);
    }

    public String getFILLER14() {
        return String.valueOf(getOIVPM04I().getTERML())
                + getOIVPM04I().getTERMF();
    }

    public void setFILLER14(String source) {
        OIVPM04I.setTERML(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setTERMF(source.substring(2));
    }

    public String getTERMO() {
        return getOIVPM04I().getTERMI();
    }

    public void setTERMO(String source) {
        OIVPM04I.setTERMI(source);
    }

    public String getFILLER15() {
        return String.valueOf(getOIVPM04I().getTIMEL())
                + getOIVPM04I().getTIMEF();
    }

    public void setFILLER15(String source) {
        OIVPM04I.setTIMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setTIMEF(source.substring(2));
    }

    public String getTIMEO() {
        return getOIVPM04I().getTIMEI();
    }

    public void setTIMEO(String source) {
        OIVPM04I.setTIMEI(source);
    }

    public String getFILLER16() {
        return String.valueOf(getOIVPM04I().getIDENL())
                + getOIVPM04I().getIDENF();
    }

    public void setFILLER16(String source) {
        OIVPM04I.setIDENL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setIDENF(source.substring(2));
    }

    public String getIDENO() {
        return getOIVPM04I().getIDENI();
    }

    public void setIDENO(String source) {
        OIVPM04I.setIDENI(source);
    }

    public String getFILLER17() {
        return String.valueOf(getOIVPM04I().getNAMEL())
                + getOIVPM04I().getNAMEF();
    }

    public void setFILLER17(String source) {
        OIVPM04I.setNAMEL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setNAMEF(source.substring(2));
    }

    public String getNAMEO() {
        return getOIVPM04I().getNAMEI();
    }

    public void setNAMEO(String source) {
        OIVPM04I.setNAMEI(source);
    }

    public String getFILLER18() {
        return String.valueOf(getOIVPM04I().getDEPTL())
                + getOIVPM04I().getDEPTF();
    }

    public void setFILLER18(String source) {
        OIVPM04I.setDEPTL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setDEPTF(source.substring(2));
    }

    public String getDEPTO() {
        return getOIVPM04I().getDEPTI();
    }

    public void setDEPTO(String source) {
        OIVPM04I.setDEPTI(source);
    }

    public String getFILLER19() {
        return String.valueOf(getOIVPM04I().getPHONL())
                + getOIVPM04I().getPHONF();
    }

    public void setFILLER19(String source) {
        OIVPM04I.setPHONL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setPHONF(source.substring(2));
    }

    public String getPHONO() {
        return getOIVPM04I().getPHONI();
    }

    public void setPHONO(String source) {
        OIVPM04I.setPHONI(source);
    }

    public String getFILLER20() {
        return String.valueOf(getOIVPM04I().getEMALL())
                + getOIVPM04I().getEMALF();
    }

    public void setFILLER20(String source) {
        OIVPM04I.setEMALL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setEMALF(source.substring(2));
    }

    public String getEMALO() {
        return getOIVPM04I().getEMALI();
    }

    public void setEMALO(String source) {
        OIVPM04I.setEMALI(source);
    }

    public String getFILLER21() {
        return String.valueOf(getOIVPM04I().getADDRL())
                + getOIVPM04I().getADDRF();
    }

    public void setFILLER21(String source) {
        OIVPM04I.setADDRL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setADDRF(source.substring(2));
    }

    public String getADDRO() {
        return getOIVPM04I().getADDRI();
    }

    public void setADDRO(String source) {
        OIVPM04I.setADDRI(source);
    }

    public String getFILLER22() {
        return String.valueOf(getOIVPM04I().getMSGL())
                + getOIVPM04I().getMSGF();
    }

    public void setFILLER22(String source) {
        OIVPM04I.setMSGL(Integer.parseInt(source.substring(0, 2)));
        OIVPM04I.setMSGF(source.substring(2));
    }

    public String getMSGO() {
        return getOIVPM04I().getMSGI();
    }

    public void setMSGO(String source) {
        OIVPM04I.setMSGI(source);
    }

    public @Getter String DEFINITIONS_OF_EIBAID_FIELD = StringUtils.repeat(' ',
            1);
    public @Getter @Setter OIVPINSR_WS_DATE_TIME_AREA WS_DATE_TIME_AREA = new OIVPINSR_WS_DATE_TIME_AREA();
    public @Getter String FILE01 = "OIVPFILE";
    public @Getter @Setter int KEY01 = 0;
    public @Getter @Setter int LEN = 4;
    public @Getter @Setter int START_KEY = 0;
    public @Getter @Setter int DATALEN = 104;
    public @Getter @Setter OIVPINSR_PEOPLE_INFO PEOPLE_INFO = new OIVPINSR_PEOPLE_INFO();
    public @Getter String START_CODE = StringUtils.repeat(' ', 2);
    public @Getter String DFHCOMMAREA = StringUtils.repeat(' ', 1);
    private final static BiFunction<Long, String, String> intFormatWithSign = (
            value, format) -> {
        DecimalFormat nf = new DecimalFormat();
        nf.applyPattern("+" + format + ";-" + format);
        return nf.format(value);
    };

    public void setWS_TRANS_ID(String source) {
        WS_TRANS_ID = StringUtils.truncate(StringUtils.rightPad(source, 4), 4);
    }

    public void setWS_MAPSET_NAME(String source) {
        WS_MAPSET_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7),
                7);
    }

    public void setWS_MAP_NAME(String source) {
        WS_MAP_NAME = StringUtils.truncate(StringUtils.rightPad(source, 7), 7);
    }

    public String getStringWS_RESPONSE_CODE() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE, "00000000");
    }

    public String getStringWS_RESPONSE_CODE2() {
        return intFormatWithSign.apply((long) WS_RESPONSE_CODE2, "00000000");
    }

    public void setWS_COMMUNICATION_AREA(String source) {
        WS_COMMUNICATION_AREA = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public String getStringWS_FIRST_TIME_FLAG() {
        return intFormatWithSign.apply((long) WS_FIRST_TIME_FLAG, "0000");
    }

    public void setDEFINITIONS_OF_EIBAID_FIELD(String source) {
        DEFINITIONS_OF_EIBAID_FIELD = StringUtils.truncate(
                StringUtils.rightPad(source, 1), 1);
    }

    public void setFILE01(String source) {
        FILE01 = StringUtils.truncate(StringUtils.rightPad(source, 8), 8);
    }

    public String getStringKEY01() {
        return intFormatWithSign.apply((long) KEY01, "00000000");
    }

    public String getStringLEN() {
        return intFormatWithSign.apply((long) LEN, "0000");
    }

    public String getStringSTART_KEY() {
        return intFormatWithSign.apply((long) START_KEY, "00000000");
    }

    public String getStringDATALEN() {
        return intFormatWithSign.apply((long) DATALEN, "0000");
    }

    public void setSTART_CODE(String source) {
        START_CODE = StringUtils.truncate(StringUtils.rightPad(source, 2), 2);
    }

    public void setDFHCOMMAREA(String source) {
        DFHCOMMAREA = StringUtils.truncate(StringUtils.rightPad(source, 1), 1);
    }
}
